* ----------------------- FAXPRO2.PRG ------------------------------------*
* Written by: Mike Reed, CompuSolve      Date: 11/01/94
* This sample program demonstrates how to fax two (or more) files
* using the FAXpro xBASE library.  It has been written using dBASEIII
* syntax so as to be compatible with virtually any xBASE language.
* Program assumes you have a CAS Resident Manager installed and that
* the fax/modem hardware has been set up to use multiplex number xCB,
* the default for Intel SatisFAXtion units.

SET TALK OFF
SET ESCAPE OFF
* LOAD the FAXPRO.BIN library
LOAD FAXPRO

SET CONFIRM ON
CLEAR
CrLf = CHR(13) + CHR(10)  && Define carr ret/line feed pair

* Issue a BOARD command so FAXpro recognizes our CAS fax board
BoardCmd = "BOARD #1, xCB"
CALL FAXPRO WITH BoardCmd
IF LEFT(BoardCmd, 2) <> "BO"   && Check if FAXpro returned an error code
  ? "BOARD command failed. Resident Manager not installed or fax board"
  ? "is set to use a multiplex number other than xCB."
  ? "Hit any key ..."
  DO WHILE INKEY() = 0
  ENDDO
  CANCEL
ENDIF

* Prompt for 2 filenames to send and recipient's name and fax number
STORE SPACE(30) TO FileNm1, FileNm2, RecipNm, RecipNo
@  8,5 SAY "File #1 (drive:\path\name)" GET FileNm1
@  9,5 SAY "File #2 (drive:\path\name)" GET FileNm2
@ 10,5 SAY "Name of recipient" GET RecipNm
@ 11,5 SAY "Fax number of recipient" GET RecipNo
READ

* Ask user if they want to send the fax
@ 12,5 SAY "Choice (0=cancel fax, 1=send fax) ? "
keypress = INKEY()
DO WHILE keypress < 48 .OR. keypress > 49
  keypress = INKEY()
ENDDO

IF keypress <> 49			&& If other than "1", exit
  CANCEL
ENDIF

* User wants to send the fax. CREATE a Control File. Syntax is:
* "CREATE #<b>,<et>,<tt>,<p>,[r],[s],[h],[d],[t],[l]"
EType = "S"    && Event Type <et> = Send
TType = "1"	   && Transfer Type <tt> = 1 (normal resol 100x200 dpi)
RecipNo = TRIM(RecipNo)  && <p>
RecipNm = TRIM(RecipNm)  && <r>
SenderNm = "Your Name Here ..."  && [s] = Sender's name
CreateCmd = "CREATE #1,&EType,&TType,&RecipNo,&RecipNm,&SenderNm"
CALL FAXPRO WITH CreateCmd

* Now let's add the text for an optional cover sheet
* "COVER #<b>,<t>"
CoverTxt = "This is line 1 of my cover page text." + CrLf + ;
  "And, this is line 2."
CoverCmd = "COVER #1," + CoverTxt
CALL FAXPRO WITH CoverCmd


* Add each file to send with the QFILE command. Syntax is:
* "QFILE #<b>,<f>,[t],[s],[l],[i]"
FileNm1 = TRIM(FileNm1)  && Remove any trailing spaces <f>
FileType = "A" && Fax file type is Ascii <t>
TxtSz = "80"   && Fax text size 80 chars across page <s>
* Add 1st file
QueueCmd1 = "QFILE #1,&FileNm1,&FileType,&TxtSz"
CALL FAXPRO WITH QueueCmd1

* Add 2nd file
FileNm2 = TRIM(FileNm2)  && <f>
QueueCmd2 = "QFILE #1,&FileNm2,&FileType,&TxtSz"
CALL FAXPRO WITH QueueCmd2


* Now, SUBMIT this task we've created. Syntax is:
* "SUBMIT #<b>, <tag>"
ApplTag = "This task created by the FAXPRO library from CompuSolve."
SubmitCmd = "SUBMIT #1," + ApplTag
CALL FAXPRO WITH SubmitCmd

IF LEFT(SubmitCmd, 2) <> "SU"	&& Check if error code was returned
  ? "SUBMIT command failed.  Error code: " + LEFT(SubmitCmd, 5)
  ? "Hit any key ..."
  DO WHILE INKEY() = 0
  ENDDO
  CANCEL
ENDIF

* Get the event handle for the task just SUBMITted.
GetHndl = "GETRESULT"
CALL FAXPRO WITH GetHndl
EvtHndl = TRIM(GetHndl)

* Fax task has been sent to Resident Manager
* Now keep displaying the current event status until user hits ESC
@ 14,0 TO 19,79 DOUBLE
@ 14,25 SAY " STATUS  (press ESC to exit) "
DO WHILE INKEY() <> 27
  * Get a few of the fields that STATUS can return for current event
  StatCmd = "STATUS #1,0, ,EVENT,TYPE,STATUS,TO,PHONE,FPSENT,DURATION"
  CALL FAXPRO WITH StatCmd
  IF LEFT(StatCmd, 2) <> "ST"
    @ 16,1 CLEAR TO 17,78
    @ 17,1 SAY "SYSTEM IDLE - NO CURRENT EVENT TO REPORT ..."
  ELSE
    Status = "GETRESULT" + SPACE(100)
    CALL faxpro WITH Status
    @ 16,1 CLEAR TO 17,78
    @ 16,1 SAY "EVENT NUMBER: " + EvtHndl
    @ 17,1 SAY TRIM(STATUS)
  ENDIF
ENDDO
